﻿'Socketクラスの呼び出し
Imports System
Imports System.Text
Imports System.IO
Imports System.Net
Imports System.Net.Sockets
Imports Microsoft.VisualBasic


Public Class Form1
    '共通変数の定義
    Dim RcvBuf As Byte()                '受信バッファ
    Dim returnData As String
    Dim Temp As Long                    '計測データ用
    Dim Ondo As Double
    Dim Humi As Double
    Dim Pres As Double
    '送信コマンドデータ定義
    Dim SWInput As Byte() = Encoding.ASCII.GetBytes("SBE")
    Dim LED1On As Byte() = Encoding.ASCII.GetBytes("SC11E")
    Dim LED1Off As Byte() = Encoding.ASCII.GetBytes("SC10E")
    Dim LED2On As Byte() = Encoding.ASCII.GetBytes("SC21E")
    Dim LED2Off As Byte() = Encoding.ASCII.GetBytes("SC20E")
    Dim Mesure As Byte() = Encoding.ASCII.GetBytes("SAE")
    Dim Shut As Byte() = Encoding.ASCII.GetBytes("SNE")

    'Socketクラス インスタンス生成
    Dim udpClientA As New UdpClient(3000)           'ローカルポート3000でインスタンス生成
    'リモートホスト定義（任意アドレス）
    Dim RemoteIPEndPoint As IPEndPoint = Nothing    '相手は特に決めない
 
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Timer1.Enabled = False                      'タイマは停止させる
        Timer3.Enabled = False
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'リモートの接続（IPアドレスで指定）
        Try
            udpClientA.Connect("192.168.1.24", 2000)    '通信相手を特定する
            TextBox1.Text = "接続成功!"
            Timer3.Interval() = 10                      '10msecタイマ起動
            Timer3.Enabled() = True                     'タイマ１起動
        Catch ex As Exception
            TextBox1.Text = "接続失敗?"
        End Try
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        udpClientA.Send(Shut, Shut.Length)
        Timer3.Enabled = False
        Timer1.Enabled = False      'タイマ１停止
        udpClientA.Close()          'UDPのクローズ
        Close()
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        '現在状態によりオンオフを反転制御
        If Button3.Text = "On" Then
            udpClientA.Send(LED1Off, LED1Off.Length)
        Else
            udpClientA.Send(LED1On, LED1On.Length)
        End If
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        '現在状態によりオンオフを反転制御
        If Button4.Text = "On" Then
            udpClientA.Send(LED2Off, LED2Off.Length)
        Else
            udpClientA.Send(LED2On, LED2On.Length)
        End If
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        'スイッチ状態入力コマンド送信
        udpClientA.Send(SWInput, SWInput.Length)
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        '計測要求用タイマ起動
        If Timer1.Enabled = False Then
            Timer1.Interval() = 3000     '3000msecタイマ起動
            Timer1.Enabled() = True     'タイマ１起動
            Button6.Text = "停止"
            ProgressBar1.Maximum = 1024
            ProgressBar1.Minimum = 0
        Else
            Timer1.Enabled = False
            Button6.Text = "計測"
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        '計測要求
        udpClientA.Send(Mesure, Mesure.Length)
    End Sub

    Private Sub Timer3_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer3.Tick
        Dim data As Integer

        '受信データがある場合受信実行
        If udpClientA.Available > 0 Then
            '受信実行
            RcvBuf = udpClientA.Receive(RemoteIPEndPoint)
            '受信データの処理
            If RcvBuf(0) = &H4D Then                          'Mの場合
                ' ***** 状態の応答の場合 *****
                If RcvBuf(1) = &H42 Then                      'Bの場合
                    'Xが0か1でオンオフ表示制御
                    If RcvBuf(2) = &H30 Then
                        TextBox2.BackColor = Color.Red
                    Else
                        TextBox2.BackColor = Color.Green
                    End If
                    If RcvBuf(3) = &H30 Then
                        TextBox3.BackColor = Color.Red
                    Else
                        TextBox3.BackColor = Color.Green
                    End If
                    If RcvBuf(4) = &H30 Then
                        TextBox4.BackColor = Color.Red
                    Else
                        TextBox4.BackColor = Color.Green
                    End If
                    If RcvBuf(5) = &H30 Then
                        TextBox5.BackColor = Color.Red
                    Else
                        TextBox5.BackColor = Color.Green
                    End If
                    ' ***** 制御の応答の場合 *****
                ElseIf RcvBuf(1) = &H43 Then                  'Cの場合
                    If RcvBuf(2) = &H31 Then                  '出力1の場合
                        'オンオフ状態により色とテキストを変更
                        If RcvBuf(3) = &H31 Then
                            Button3.BackColor = Color.Red
                            Button3.Text = "On"
                        Else
                            Button3.BackColor = Color.Green
                            Button3.Text = "Off"
                        End If
                    ElseIf RcvBuf(2) = &H32 Then              '出力2の場合
                        'オンオフ状態により色とテキストを変更
                        If RcvBuf(3) = &H31 Then
                            Button4.BackColor = Color.Red
                            Button4.Text = "On"
                        Else
                            Button4.BackColor = Color.Green
                            Button4.Text = "Off"
                        End If
                    End If
                    ' ***** 計測応答の場合 *****
                ElseIf RcvBuf(1) = &H41 Then                  'Aの場合
                    '温度データ変換と表示
                    Temp = RcvBuf(3) * 256 + RcvBuf(4)
                    Ondo = 0.01 * Temp - 39.7
                    TextBox6.Text = Ondo.ToString("F1")
                    '湿度データ変換と表示
                    Temp = RcvBuf(6) * 256 + RcvBuf(7)
                    Humi = 0.0367 * Temp - 2.048
                    Humi += (Ondo - 25.9) * (0.01 + 0.00008 * Temp)
                    TextBox7.Text = Humi.ToString("F1")
                    '気圧データ変換と表示
                    Temp = RcvBuf(9) * 256 + RcvBuf(10)
                    Pres = Temp / 10.0
                    TextBox8.Text = Pres.ToString("F1")
                    '照度データ変換と表示
                    Temp = RcvBuf(11) * 256 + RcvBuf(12)
                    If (Temp < 1024) Then
                        ProgressBar1.Value = Temp
                    End If
                    '汎用計測追加表示
                    data = RcvBuf(13) * 256 + RcvBuf(14)
                    TextBox9.Text = data.ToString("F0")
                    data = RcvBuf(15) * 256 + RcvBuf(16)
                    TextBox10.Text = data.ToString("F0")
                    data = RcvBuf(17) * 256 + RcvBuf(18)
                    TextBox11.Text = data.ToString("F0")
                    data = RcvBuf(19) * 256 + RcvBuf(20)
                    TextBox12.Text = data.ToString("F0")
                End If
            End If
        End If
    End Sub
End Class
